Index: commdlg/printdlg.h
===================================================================
RCS file: /home/wine/wine/dlls/commdlg/printdlg.h,v
retrieving revision 1.4
diff -u -r1.4 printdlg.h
--- commdlg/printdlg.h	2 Jan 2004 01:49:32 -0000	1.4
+++ commdlg/printdlg.h	4 Jan 2004 17:52:04 -0000
@@ -25,11 +25,9 @@
 #define _WINE_PRINTDLG_H
 
 #include "cdlg.h"
-#include "cdlg16.h"
 
 /* This PRINTDLGA internal structure stores
  * pointers to several throughout useful structures.
- *
  */
 
 typedef struct
@@ -37,7 +35,6 @@
   LPDEVMODEA        lpDevMode;
   struct {
       LPPRINTDLGA       lpPrintDlg;
-      LPPRINTDLG16	lpPrintDlg16;
   } dlg;
   LPPRINTER_INFO_2A lpPrinterInfo;
   LPDRIVER_INFO_3A  lpDriverInfo;
Index: commdlg/printdlg16.c
===================================================================
RCS file: /home/wine/wine/dlls/commdlg/printdlg16.c,v
retrieving revision 1.7
diff -u -r1.7 printdlg16.c
--- commdlg/printdlg16.c	2 Jan 2004 01:49:32 -0000	1.7
+++ commdlg/printdlg16.c	4 Jan 2004 17:52:05 -0000
@@ -48,6 +48,31 @@
 #include "cdlg16.h"
 #include "printdlg.h"
 
+/* This PRINTDLGA16 internal structure stores
+ * pointers to several throughout useful structures.
+ * This structure is a duplicate of the PRINT_PTRA
+ * struct with a extra memeber.
+ */
+
+typedef struct
+{
+  LPDEVMODEA        lpDevMode;
+  struct {
+      LPPRINTDLGA       lpPrintDlg;
+      LPPRINTDLG16	lpPrintDlg16;
+  } dlg;
+  LPPRINTER_INFO_2A lpPrinterInfo;
+  LPDRIVER_INFO_3A  lpDriverInfo;
+  UINT              HelpMessageID;
+  HICON             hCollateIcon;    /* PrintDlg only */
+  HICON             hNoCollateIcon;  /* PrintDlg only */
+  HICON             hPortraitIcon;   /* PrintSetupDlg only */
+  HICON             hLandscapeIcon;  /* PrintSetupDlg only */
+  HWND              hwndUpDown;
+} PRINT_PTRA16;
+
+/* Internal Functions */
+
 static BOOL PRINTDLG_CreateDevNames16(HGLOBAL16 *hmem, char* DeviceDriverName,
 				      char* DeviceName, char* OutputPort)
 {
@@ -96,7 +121,7 @@
  *           PRINTDLG_WMInitDialog                      [internal]
  */
 static LRESULT PRINTDLG_WMInitDialog16(HWND hDlg, WPARAM wParam,
-				     PRINT_PTRA* PrintStructures)
+				     PRINT_PTRA16* PrintStructures)
 {
     LPPRINTDLG16 lppd = PrintStructures->dlg.lpPrintDlg16;
     DEVNAMES *pdn;
@@ -312,6 +337,11 @@
     return hDlgTmpl;
 }
 
+/**********************************************************************
+ *
+ *      16 bit commdlg
+ */
+
 /***********************************************************************
  *           PrintDlg   (COMMDLG.20)
  *
@@ -400,7 +430,7 @@
 	bRet = TRUE;
     } else {
 	HGLOBAL16 hDlgTmpl;
-	PRINT_PTRA *PrintStructures;
+	PRINT_PTRA16 *PrintStructures;
 
     /* load Dialog resources,
      * depending on Flags indicates Print32 or Print32_setup dialog
@@ -411,7 +441,7 @@
 	    return FALSE;
 	}
         PrintStructures = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
-				    sizeof(PRINT_PTRA));
+				    sizeof(PRINT_PTRA16));
 	PrintStructures->dlg.lpPrintDlg16 = lppd;
 	PrintStructures->dlg.lpPrintDlg = (LPPRINTDLGA)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(PRINTDLGA));
 #define CVAL(x)	PrintStructures->dlg.lpPrintDlg->x = lppd->x;
@@ -494,11 +524,6 @@
     return bRet;
 }
 
-/**********************************************************************
- *
- *      16 bit commdlg
- */
-
 /***********************************************************************
  *           PrintDlgProc   (COMMDLG.21)
  */
@@ -506,15 +531,15 @@
                             LPARAM lParam)
 {
     HWND hDlg = HWND_32(hDlg16);
-    PRINT_PTRA* PrintStructures;
+    PRINT_PTRA16* PrintStructures;
     BOOL16 res = FALSE;
 
     if (uMsg!=WM_INITDIALOG) {
-        PrintStructures = (PRINT_PTRA*)GetPropA(hDlg,"__WINE_PRINTDLGDATA");
+        PrintStructures = (PRINT_PTRA16*)GetPropA(hDlg,"__WINE_PRINTDLGDATA");
 	if (!PrintStructures)
 	    return FALSE;
     } else {
-        PrintStructures = (PRINT_PTRA*) lParam;
+        PrintStructures = (PRINT_PTRA16*) lParam;
 	SetPropA(hDlg,"__WINE_PRINTDLGDATA",PrintStructures);
 	res = PRINTDLG_WMInitDialog16(hDlg, wParam, PrintStructures);
 
